unit schStockClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_StockPrendasCentros = '{A01C38D3-19DC-42D1-A0CB-6ABF3E9D5507}';
  RID_StockEDI = '{0CB949AB-F343-4ECF-9163-69234641CEB1}';
  RID_StockVARELA = '{DFB28AB8-F8C4-4AAD-AA73-8015541091D0}';
  RID_StockEDIInventario = '{5496215D-7A4A-43E1-929A-D0538C931177}';

  { Data table names }
  nme_StockPrendasCentros = 'StockPrendasCentros';
  nme_StockEDI = 'StockEDI';
  nme_StockVARELA = 'StockVARELA';
  nme_StockEDIInventario = 'StockEDIInventario';

  { StockPrendasCentros fields }
  fld_StockPrendasCentrosCODIGO = 'CODIGO';
  fld_StockPrendasCentrosPRODUCTO = 'PRODUCTO';
  fld_StockPrendasCentrosTIPO_PRODUCTO = 'TIPO_PRODUCTO';
  fld_StockPrendasCentrosGRUPO_PRODUCTO = 'GRUPO_PRODUCTO';
  fld_StockPrendasCentrosCOLECCION = 'COLECCION';
  fld_StockPrendasCentrosCOLOR = 'COLOR';
  fld_StockPrendasCentrosT38 = 'T38';
  fld_StockPrendasCentrosT40 = 'T40';
  fld_StockPrendasCentrosT42 = 'T42';
  fld_StockPrendasCentrosT44 = 'T44';
  fld_StockPrendasCentrosT46 = 'T46';
  fld_StockPrendasCentrosT48 = 'T48';
  fld_StockPrendasCentrosTOTAL = 'TOTAL';

  { StockPrendasCentros field indexes }
  idx_StockPrendasCentrosCODIGO = 0;
  idx_StockPrendasCentrosPRODUCTO = 1;
  idx_StockPrendasCentrosTIPO_PRODUCTO = 2;
  idx_StockPrendasCentrosGRUPO_PRODUCTO = 3;
  idx_StockPrendasCentrosCOLECCION = 4;
  idx_StockPrendasCentrosCOLOR = 5;
  idx_StockPrendasCentrosT38 = 6;
  idx_StockPrendasCentrosT40 = 7;
  idx_StockPrendasCentrosT42 = 8;
  idx_StockPrendasCentrosT44 = 9;
  idx_StockPrendasCentrosT46 = 10;
  idx_StockPrendasCentrosT48 = 11;
  idx_StockPrendasCentrosTOTAL = 12;

  { StockEDI fields }
  fld_StockEDICENTRO = 'CENTRO';
  fld_StockEDICODIGO = 'CODIGO';
  fld_StockEDIPRODUCTO = 'PRODUCTO';
  fld_StockEDITIPO_PRODUCTO = 'TIPO_PRODUCTO';
  fld_StockEDIGRUPO_PRODUCTO = 'GRUPO_PRODUCTO';
  fld_StockEDICOLECCION = 'COLECCION';
  fld_StockEDICOLOR = 'COLOR';
  fld_StockEDIE38 = 'E38';
  fld_StockEDIE40 = 'E40';
  fld_StockEDIE42 = 'E42';
  fld_StockEDIE44 = 'E44';
  fld_StockEDIE46 = 'E46';
  fld_StockEDIE48 = 'E48';
  fld_StockEDITE = 'TE';
  fld_StockEDIS38 = 'S38';
  fld_StockEDIS40 = 'S40';
  fld_StockEDIS42 = 'S42';
  fld_StockEDIS44 = 'S44';
  fld_StockEDIS46 = 'S46';
  fld_StockEDIS48 = 'S48';
  fld_StockEDITS = 'TS';
  fld_StockEDIK38 = 'K38';
  fld_StockEDIK40 = 'K40';
  fld_StockEDIK42 = 'K42';
  fld_StockEDIK44 = 'K44';
  fld_StockEDIK46 = 'K46';
  fld_StockEDIK48 = 'K48';
  fld_StockEDIKT = 'KT';

  { StockEDI field indexes }
  idx_StockEDICENTRO = 0;
  idx_StockEDICODIGO = 1;
  idx_StockEDIPRODUCTO = 2;
  idx_StockEDITIPO_PRODUCTO = 3;
  idx_StockEDIGRUPO_PRODUCTO = 4;
  idx_StockEDICOLECCION = 5;
  idx_StockEDICOLOR = 6;
  idx_StockEDIE38 = 7;
  idx_StockEDIE40 = 8;
  idx_StockEDIE42 = 9;
  idx_StockEDIE44 = 10;
  idx_StockEDIE46 = 11;
  idx_StockEDIE48 = 12;
  idx_StockEDITE = 13;
  idx_StockEDIS38 = 14;
  idx_StockEDIS40 = 15;
  idx_StockEDIS42 = 16;
  idx_StockEDIS44 = 17;
  idx_StockEDIS46 = 18;
  idx_StockEDIS48 = 19;
  idx_StockEDITS = 20;
  idx_StockEDIK38 = 21;
  idx_StockEDIK40 = 22;
  idx_StockEDIK42 = 23;
  idx_StockEDIK44 = 24;
  idx_StockEDIK46 = 25;
  idx_StockEDIK48 = 26;
  idx_StockEDIKT = 27;

  { StockVARELA fields }
  fld_StockVARELAFILIAL = 'FILIAL';
  fld_StockVARELACODIGO = 'CODIGO';
  fld_StockVARELACOLOR = 'COLOR';
  fld_StockVARELAPRODUCTO = 'PRODUCTO';
  fld_StockVARELATIPO_PRODUTO = 'TIPO_PRODUTO';
  fld_StockVARELAGRUPO_PRODUTO = 'GRUPO_PRODUTO';
  fld_StockVARELACOLECCION = 'COLECCION';
  fld_StockVARELAK38 = 'K38';
  fld_StockVARELAK40 = 'K40';
  fld_StockVARELAK42 = 'K42';
  fld_StockVARELAK44 = 'K44';
  fld_StockVARELAK46 = 'K46';
  fld_StockVARELAK48 = 'K48';
  fld_StockVARELAKT = 'KT';

  { StockVARELA field indexes }
  idx_StockVARELAFILIAL = 0;
  idx_StockVARELACODIGO = 1;
  idx_StockVARELACOLOR = 2;
  idx_StockVARELAPRODUCTO = 3;
  idx_StockVARELATIPO_PRODUTO = 4;
  idx_StockVARELAGRUPO_PRODUTO = 5;
  idx_StockVARELACOLECCION = 6;
  idx_StockVARELAK38 = 7;
  idx_StockVARELAK40 = 8;
  idx_StockVARELAK42 = 9;
  idx_StockVARELAK44 = 10;
  idx_StockVARELAK46 = 11;
  idx_StockVARELAK48 = 12;
  idx_StockVARELAKT = 13;

  { StockEDIInventario fields }
  fld_StockEDIInventarioCENTRO = 'CENTRO';
  fld_StockEDIInventarioCODIGO = 'CODIGO';
  fld_StockEDIInventarioPRODUCTO = 'PRODUCTO';
  fld_StockEDIInventarioCOLOR = 'COLOR';
  fld_StockEDIInventarioTIPO_PRODUCTO = 'TIPO_PRODUCTO';
  fld_StockEDIInventarioGRUPO_PRODUCTO = 'GRUPO_PRODUCTO';
  fld_StockEDIInventarioCOLECCION = 'COLECCION';
  fld_StockEDIInventarioI38 = 'I38';
  fld_StockEDIInventarioI40 = 'I40';
  fld_StockEDIInventarioI42 = 'I42';
  fld_StockEDIInventarioI44 = 'I44';
  fld_StockEDIInventarioI46 = 'I46';
  fld_StockEDIInventarioI48 = 'I48';
  fld_StockEDIInventarioTI = 'TI';
  fld_StockEDIInventarioK38 = 'K38';
  fld_StockEDIInventarioK40 = 'K40';
  fld_StockEDIInventarioK42 = 'K42';
  fld_StockEDIInventarioK44 = 'K44';
  fld_StockEDIInventarioK46 = 'K46';
  fld_StockEDIInventarioK48 = 'K48';
  fld_StockEDIInventarioTK = 'TK';
  fld_StockEDIInventarioD38 = 'D38';
  fld_StockEDIInventarioD40 = 'D40';
  fld_StockEDIInventarioD42 = 'D42';
  fld_StockEDIInventarioD44 = 'D44';
  fld_StockEDIInventarioD46 = 'D46';
  fld_StockEDIInventarioD48 = 'D48';
  fld_StockEDIInventarioDT = 'DT';

  { StockEDIInventario field indexes }
  idx_StockEDIInventarioCENTRO = 0;
  idx_StockEDIInventarioCODIGO = 1;
  idx_StockEDIInventarioPRODUCTO = 2;
  idx_StockEDIInventarioCOLOR = 3;
  idx_StockEDIInventarioTIPO_PRODUCTO = 4;
  idx_StockEDIInventarioGRUPO_PRODUCTO = 5;
  idx_StockEDIInventarioCOLECCION = 6;
  idx_StockEDIInventarioI38 = 7;
  idx_StockEDIInventarioI40 = 8;
  idx_StockEDIInventarioI42 = 9;
  idx_StockEDIInventarioI44 = 10;
  idx_StockEDIInventarioI46 = 11;
  idx_StockEDIInventarioI48 = 12;
  idx_StockEDIInventarioTI = 13;
  idx_StockEDIInventarioK38 = 14;
  idx_StockEDIInventarioK40 = 15;
  idx_StockEDIInventarioK42 = 16;
  idx_StockEDIInventarioK44 = 17;
  idx_StockEDIInventarioK46 = 18;
  idx_StockEDIInventarioK48 = 19;
  idx_StockEDIInventarioTK = 20;
  idx_StockEDIInventarioD38 = 21;
  idx_StockEDIInventarioD40 = 22;
  idx_StockEDIInventarioD42 = 23;
  idx_StockEDIInventarioD44 = 24;
  idx_StockEDIInventarioD46 = 25;
  idx_StockEDIInventarioD48 = 26;
  idx_StockEDIInventarioDT = 27;

type
  { IStockPrendasCentros }
  IStockPrendasCentros = interface(IDAStronglyTypedDataTable)
  ['{9147A7A9-8562-4C08-8D0F-4E08050ED78D}']
    { Property getters and setters }
    function GetCODIGOValue: String;
    procedure SetCODIGOValue(const aValue: String);
    function GetPRODUCTOValue: String;
    procedure SetPRODUCTOValue(const aValue: String);
    function GetTIPO_PRODUCTOValue: String;
    procedure SetTIPO_PRODUCTOValue(const aValue: String);
    function GetGRUPO_PRODUCTOValue: String;
    procedure SetGRUPO_PRODUCTOValue(const aValue: String);
    function GetCOLECCIONValue: String;
    procedure SetCOLECCIONValue(const aValue: String);
    function GetCOLORValue: String;
    procedure SetCOLORValue(const aValue: String);
    function GetT38Value: Float;
    procedure SetT38Value(const aValue: Float);
    function GetT40Value: Float;
    procedure SetT40Value(const aValue: Float);
    function GetT42Value: Float;
    procedure SetT42Value(const aValue: Float);
    function GetT44Value: Float;
    procedure SetT44Value(const aValue: Float);
    function GetT46Value: Float;
    procedure SetT46Value(const aValue: Float);
    function GetT48Value: Float;
    procedure SetT48Value(const aValue: Float);
    function GetTOTALValue: Float;
    procedure SetTOTALValue(const aValue: Float);


    { Properties }
    property CODIGO: String read GetCODIGOValue write SetCODIGOValue;
    property PRODUCTO: String read GetPRODUCTOValue write SetPRODUCTOValue;
    property TIPO_PRODUCTO: String read GetTIPO_PRODUCTOValue write SetTIPO_PRODUCTOValue;
    property GRUPO_PRODUCTO: String read GetGRUPO_PRODUCTOValue write SetGRUPO_PRODUCTOValue;
    property COLECCION: String read GetCOLECCIONValue write SetCOLECCIONValue;
    property COLOR: String read GetCOLORValue write SetCOLORValue;
    property T38: Float read GetT38Value write SetT38Value;
    property T40: Float read GetT40Value write SetT40Value;
    property T42: Float read GetT42Value write SetT42Value;
    property T44: Float read GetT44Value write SetT44Value;
    property T46: Float read GetT46Value write SetT46Value;
    property T48: Float read GetT48Value write SetT48Value;
    property TOTAL: Float read GetTOTALValue write SetTOTALValue;
  end;

  { TStockPrendasCentrosDataTableRules }
  TStockPrendasCentrosDataTableRules = class(TDADataTableRules, IStockPrendasCentros)
  private
  protected
    { Property getters and setters }
    function GetCODIGOValue: String; virtual;
    procedure SetCODIGOValue(const aValue: String); virtual;
    function GetPRODUCTOValue: String; virtual;
    procedure SetPRODUCTOValue(const aValue: String); virtual;
    function GetTIPO_PRODUCTOValue: String; virtual;
    procedure SetTIPO_PRODUCTOValue(const aValue: String); virtual;
    function GetGRUPO_PRODUCTOValue: String; virtual;
    procedure SetGRUPO_PRODUCTOValue(const aValue: String); virtual;
    function GetCOLECCIONValue: String; virtual;
    procedure SetCOLECCIONValue(const aValue: String); virtual;
    function GetCOLORValue: String; virtual;
    procedure SetCOLORValue(const aValue: String); virtual;
    function GetT38Value: Float; virtual;
    procedure SetT38Value(const aValue: Float); virtual;
    function GetT40Value: Float; virtual;
    procedure SetT40Value(const aValue: Float); virtual;
    function GetT42Value: Float; virtual;
    procedure SetT42Value(const aValue: Float); virtual;
    function GetT44Value: Float; virtual;
    procedure SetT44Value(const aValue: Float); virtual;
    function GetT46Value: Float; virtual;
    procedure SetT46Value(const aValue: Float); virtual;
    function GetT48Value: Float; virtual;
    procedure SetT48Value(const aValue: Float); virtual;
    function GetTOTALValue: Float; virtual;
    procedure SetTOTALValue(const aValue: Float); virtual;

    { Properties }
    property CODIGO: String read GetCODIGOValue write SetCODIGOValue;
    property PRODUCTO: String read GetPRODUCTOValue write SetPRODUCTOValue;
    property TIPO_PRODUCTO: String read GetTIPO_PRODUCTOValue write SetTIPO_PRODUCTOValue;
    property GRUPO_PRODUCTO: String read GetGRUPO_PRODUCTOValue write SetGRUPO_PRODUCTOValue;
    property COLECCION: String read GetCOLECCIONValue write SetCOLECCIONValue;
    property COLOR: String read GetCOLORValue write SetCOLORValue;
    property T38: Float read GetT38Value write SetT38Value;
    property T40: Float read GetT40Value write SetT40Value;
    property T42: Float read GetT42Value write SetT42Value;
    property T44: Float read GetT44Value write SetT44Value;
    property T46: Float read GetT46Value write SetT46Value;
    property T48: Float read GetT48Value write SetT48Value;
    property TOTAL: Float read GetTOTALValue write SetTOTALValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IStockEDI }
  IStockEDI = interface(IDAStronglyTypedDataTable)
  ['{759266B9-20F4-4F29-9B8B-96F6E62E2560}']
    { Property getters and setters }
    function GetCENTROValue: String;
    procedure SetCENTROValue(const aValue: String);
    function GetCODIGOValue: String;
    procedure SetCODIGOValue(const aValue: String);
    function GetPRODUCTOValue: String;
    procedure SetPRODUCTOValue(const aValue: String);
    function GetTIPO_PRODUCTOValue: String;
    procedure SetTIPO_PRODUCTOValue(const aValue: String);
    function GetGRUPO_PRODUCTOValue: String;
    procedure SetGRUPO_PRODUCTOValue(const aValue: String);
    function GetCOLECCIONValue: String;
    procedure SetCOLECCIONValue(const aValue: String);
    function GetCOLORValue: String;
    procedure SetCOLORValue(const aValue: String);
    function GetE38Value: Float;
    procedure SetE38Value(const aValue: Float);
    function GetE40Value: Float;
    procedure SetE40Value(const aValue: Float);
    function GetE42Value: Float;
    procedure SetE42Value(const aValue: Float);
    function GetE44Value: Float;
    procedure SetE44Value(const aValue: Float);
    function GetE46Value: Float;
    procedure SetE46Value(const aValue: Float);
    function GetE48Value: Float;
    procedure SetE48Value(const aValue: Float);
    function GetTEValue: Float;
    procedure SetTEValue(const aValue: Float);
    function GetS38Value: Float;
    procedure SetS38Value(const aValue: Float);
    function GetS40Value: Float;
    procedure SetS40Value(const aValue: Float);
    function GetS42Value: Float;
    procedure SetS42Value(const aValue: Float);
    function GetS44Value: Float;
    procedure SetS44Value(const aValue: Float);
    function GetS46Value: Float;
    procedure SetS46Value(const aValue: Float);
    function GetS48Value: Float;
    procedure SetS48Value(const aValue: Float);
    function GetTSValue: Float;
    procedure SetTSValue(const aValue: Float);
    function GetK38Value: Float;
    procedure SetK38Value(const aValue: Float);
    function GetK40Value: Float;
    procedure SetK40Value(const aValue: Float);
    function GetK42Value: Float;
    procedure SetK42Value(const aValue: Float);
    function GetK44Value: Float;
    procedure SetK44Value(const aValue: Float);
    function GetK46Value: Float;
    procedure SetK46Value(const aValue: Float);
    function GetK48Value: Float;
    procedure SetK48Value(const aValue: Float);
    function GetKTValue: Float;
    procedure SetKTValue(const aValue: Float);


    { Properties }
    property CENTRO: String read GetCENTROValue write SetCENTROValue;
    property CODIGO: String read GetCODIGOValue write SetCODIGOValue;
    property PRODUCTO: String read GetPRODUCTOValue write SetPRODUCTOValue;
    property TIPO_PRODUCTO: String read GetTIPO_PRODUCTOValue write SetTIPO_PRODUCTOValue;
    property GRUPO_PRODUCTO: String read GetGRUPO_PRODUCTOValue write SetGRUPO_PRODUCTOValue;
    property COLECCION: String read GetCOLECCIONValue write SetCOLECCIONValue;
    property COLOR: String read GetCOLORValue write SetCOLORValue;
    property E38: Float read GetE38Value write SetE38Value;
    property E40: Float read GetE40Value write SetE40Value;
    property E42: Float read GetE42Value write SetE42Value;
    property E44: Float read GetE44Value write SetE44Value;
    property E46: Float read GetE46Value write SetE46Value;
    property E48: Float read GetE48Value write SetE48Value;
    property TE: Float read GetTEValue write SetTEValue;
    property S38: Float read GetS38Value write SetS38Value;
    property S40: Float read GetS40Value write SetS40Value;
    property S42: Float read GetS42Value write SetS42Value;
    property S44: Float read GetS44Value write SetS44Value;
    property S46: Float read GetS46Value write SetS46Value;
    property S48: Float read GetS48Value write SetS48Value;
    property TS: Float read GetTSValue write SetTSValue;
    property K38: Float read GetK38Value write SetK38Value;
    property K40: Float read GetK40Value write SetK40Value;
    property K42: Float read GetK42Value write SetK42Value;
    property K44: Float read GetK44Value write SetK44Value;
    property K46: Float read GetK46Value write SetK46Value;
    property K48: Float read GetK48Value write SetK48Value;
    property KT: Float read GetKTValue write SetKTValue;
  end;

  { TStockEDIDataTableRules }
  TStockEDIDataTableRules = class(TDADataTableRules, IStockEDI)
  private
  protected
    { Property getters and setters }
    function GetCENTROValue: String; virtual;
    procedure SetCENTROValue(const aValue: String); virtual;
    function GetCODIGOValue: String; virtual;
    procedure SetCODIGOValue(const aValue: String); virtual;
    function GetPRODUCTOValue: String; virtual;
    procedure SetPRODUCTOValue(const aValue: String); virtual;
    function GetTIPO_PRODUCTOValue: String; virtual;
    procedure SetTIPO_PRODUCTOValue(const aValue: String); virtual;
    function GetGRUPO_PRODUCTOValue: String; virtual;
    procedure SetGRUPO_PRODUCTOValue(const aValue: String); virtual;
    function GetCOLECCIONValue: String; virtual;
    procedure SetCOLECCIONValue(const aValue: String); virtual;
    function GetCOLORValue: String; virtual;
    procedure SetCOLORValue(const aValue: String); virtual;
    function GetE38Value: Float; virtual;
    procedure SetE38Value(const aValue: Float); virtual;
    function GetE40Value: Float; virtual;
    procedure SetE40Value(const aValue: Float); virtual;
    function GetE42Value: Float; virtual;
    procedure SetE42Value(const aValue: Float); virtual;
    function GetE44Value: Float; virtual;
    procedure SetE44Value(const aValue: Float); virtual;
    function GetE46Value: Float; virtual;
    procedure SetE46Value(const aValue: Float); virtual;
    function GetE48Value: Float; virtual;
    procedure SetE48Value(const aValue: Float); virtual;
    function GetTEValue: Float; virtual;
    procedure SetTEValue(const aValue: Float); virtual;
    function GetS38Value: Float; virtual;
    procedure SetS38Value(const aValue: Float); virtual;
    function GetS40Value: Float; virtual;
    procedure SetS40Value(const aValue: Float); virtual;
    function GetS42Value: Float; virtual;
    procedure SetS42Value(const aValue: Float); virtual;
    function GetS44Value: Float; virtual;
    procedure SetS44Value(const aValue: Float); virtual;
    function GetS46Value: Float; virtual;
    procedure SetS46Value(const aValue: Float); virtual;
    function GetS48Value: Float; virtual;
    procedure SetS48Value(const aValue: Float); virtual;
    function GetTSValue: Float; virtual;
    procedure SetTSValue(const aValue: Float); virtual;
    function GetK38Value: Float; virtual;
    procedure SetK38Value(const aValue: Float); virtual;
    function GetK40Value: Float; virtual;
    procedure SetK40Value(const aValue: Float); virtual;
    function GetK42Value: Float; virtual;
    procedure SetK42Value(const aValue: Float); virtual;
    function GetK44Value: Float; virtual;
    procedure SetK44Value(const aValue: Float); virtual;
    function GetK46Value: Float; virtual;
    procedure SetK46Value(const aValue: Float); virtual;
    function GetK48Value: Float; virtual;
    procedure SetK48Value(const aValue: Float); virtual;
    function GetKTValue: Float; virtual;
    procedure SetKTValue(const aValue: Float); virtual;

    { Properties }
    property CENTRO: String read GetCENTROValue write SetCENTROValue;
    property CODIGO: String read GetCODIGOValue write SetCODIGOValue;
    property PRODUCTO: String read GetPRODUCTOValue write SetPRODUCTOValue;
    property TIPO_PRODUCTO: String read GetTIPO_PRODUCTOValue write SetTIPO_PRODUCTOValue;
    property GRUPO_PRODUCTO: String read GetGRUPO_PRODUCTOValue write SetGRUPO_PRODUCTOValue;
    property COLECCION: String read GetCOLECCIONValue write SetCOLECCIONValue;
    property COLOR: String read GetCOLORValue write SetCOLORValue;
    property E38: Float read GetE38Value write SetE38Value;
    property E40: Float read GetE40Value write SetE40Value;
    property E42: Float read GetE42Value write SetE42Value;
    property E44: Float read GetE44Value write SetE44Value;
    property E46: Float read GetE46Value write SetE46Value;
    property E48: Float read GetE48Value write SetE48Value;
    property TE: Float read GetTEValue write SetTEValue;
    property S38: Float read GetS38Value write SetS38Value;
    property S40: Float read GetS40Value write SetS40Value;
    property S42: Float read GetS42Value write SetS42Value;
    property S44: Float read GetS44Value write SetS44Value;
    property S46: Float read GetS46Value write SetS46Value;
    property S48: Float read GetS48Value write SetS48Value;
    property TS: Float read GetTSValue write SetTSValue;
    property K38: Float read GetK38Value write SetK38Value;
    property K40: Float read GetK40Value write SetK40Value;
    property K42: Float read GetK42Value write SetK42Value;
    property K44: Float read GetK44Value write SetK44Value;
    property K46: Float read GetK46Value write SetK46Value;
    property K48: Float read GetK48Value write SetK48Value;
    property KT: Float read GetKTValue write SetKTValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IStockVARELA }
  IStockVARELA = interface(IDAStronglyTypedDataTable)
  ['{29240A98-CF0E-4E1C-AE1B-17DE8E33837F}']
    { Property getters and setters }
    function GetFILIALValue: String;
    procedure SetFILIALValue(const aValue: String);
    function GetCODIGOValue: String;
    procedure SetCODIGOValue(const aValue: String);
    function GetCOLORValue: String;
    procedure SetCOLORValue(const aValue: String);
    function GetPRODUCTOValue: String;
    procedure SetPRODUCTOValue(const aValue: String);
    function GetTIPO_PRODUTOValue: String;
    procedure SetTIPO_PRODUTOValue(const aValue: String);
    function GetGRUPO_PRODUTOValue: String;
    procedure SetGRUPO_PRODUTOValue(const aValue: String);
    function GetCOLECCIONValue: String;
    procedure SetCOLECCIONValue(const aValue: String);
    function GetK38Value: Integer;
    procedure SetK38Value(const aValue: Integer);
    function GetK40Value: Integer;
    procedure SetK40Value(const aValue: Integer);
    function GetK42Value: Integer;
    procedure SetK42Value(const aValue: Integer);
    function GetK44Value: Integer;
    procedure SetK44Value(const aValue: Integer);
    function GetK46Value: Integer;
    procedure SetK46Value(const aValue: Integer);
    function GetK48Value: Integer;
    procedure SetK48Value(const aValue: Integer);
    function GetKTValue: Integer;
    procedure SetKTValue(const aValue: Integer);


    { Properties }
    property FILIAL: String read GetFILIALValue write SetFILIALValue;
    property CODIGO: String read GetCODIGOValue write SetCODIGOValue;
    property COLOR: String read GetCOLORValue write SetCOLORValue;
    property PRODUCTO: String read GetPRODUCTOValue write SetPRODUCTOValue;
    property TIPO_PRODUTO: String read GetTIPO_PRODUTOValue write SetTIPO_PRODUTOValue;
    property GRUPO_PRODUTO: String read GetGRUPO_PRODUTOValue write SetGRUPO_PRODUTOValue;
    property COLECCION: String read GetCOLECCIONValue write SetCOLECCIONValue;
    property K38: Integer read GetK38Value write SetK38Value;
    property K40: Integer read GetK40Value write SetK40Value;
    property K42: Integer read GetK42Value write SetK42Value;
    property K44: Integer read GetK44Value write SetK44Value;
    property K46: Integer read GetK46Value write SetK46Value;
    property K48: Integer read GetK48Value write SetK48Value;
    property KT: Integer read GetKTValue write SetKTValue;
  end;

  { TStockVARELADataTableRules }
  TStockVARELADataTableRules = class(TDADataTableRules, IStockVARELA)
  private
  protected
    { Property getters and setters }
    function GetFILIALValue: String; virtual;
    procedure SetFILIALValue(const aValue: String); virtual;
    function GetCODIGOValue: String; virtual;
    procedure SetCODIGOValue(const aValue: String); virtual;
    function GetCOLORValue: String; virtual;
    procedure SetCOLORValue(const aValue: String); virtual;
    function GetPRODUCTOValue: String; virtual;
    procedure SetPRODUCTOValue(const aValue: String); virtual;
    function GetTIPO_PRODUTOValue: String; virtual;
    procedure SetTIPO_PRODUTOValue(const aValue: String); virtual;
    function GetGRUPO_PRODUTOValue: String; virtual;
    procedure SetGRUPO_PRODUTOValue(const aValue: String); virtual;
    function GetCOLECCIONValue: String; virtual;
    procedure SetCOLECCIONValue(const aValue: String); virtual;
    function GetK38Value: Integer; virtual;
    procedure SetK38Value(const aValue: Integer); virtual;
    function GetK40Value: Integer; virtual;
    procedure SetK40Value(const aValue: Integer); virtual;
    function GetK42Value: Integer; virtual;
    procedure SetK42Value(const aValue: Integer); virtual;
    function GetK44Value: Integer; virtual;
    procedure SetK44Value(const aValue: Integer); virtual;
    function GetK46Value: Integer; virtual;
    procedure SetK46Value(const aValue: Integer); virtual;
    function GetK48Value: Integer; virtual;
    procedure SetK48Value(const aValue: Integer); virtual;
    function GetKTValue: Integer; virtual;
    procedure SetKTValue(const aValue: Integer); virtual;

    { Properties }
    property FILIAL: String read GetFILIALValue write SetFILIALValue;
    property CODIGO: String read GetCODIGOValue write SetCODIGOValue;
    property COLOR: String read GetCOLORValue write SetCOLORValue;
    property PRODUCTO: String read GetPRODUCTOValue write SetPRODUCTOValue;
    property TIPO_PRODUTO: String read GetTIPO_PRODUTOValue write SetTIPO_PRODUTOValue;
    property GRUPO_PRODUTO: String read GetGRUPO_PRODUTOValue write SetGRUPO_PRODUTOValue;
    property COLECCION: String read GetCOLECCIONValue write SetCOLECCIONValue;
    property K38: Integer read GetK38Value write SetK38Value;
    property K40: Integer read GetK40Value write SetK40Value;
    property K42: Integer read GetK42Value write SetK42Value;
    property K44: Integer read GetK44Value write SetK44Value;
    property K46: Integer read GetK46Value write SetK46Value;
    property K48: Integer read GetK48Value write SetK48Value;
    property KT: Integer read GetKTValue write SetKTValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IStockEDIInventario }
  IStockEDIInventario = interface(IDAStronglyTypedDataTable)
  ['{ECFA34AB-357B-4817-BB85-10D0BF34884F}']
    { Property getters and setters }
    function GetCENTROValue: String;
    procedure SetCENTROValue(const aValue: String);
    function GetCODIGOValue: String;
    procedure SetCODIGOValue(const aValue: String);
    function GetPRODUCTOValue: String;
    procedure SetPRODUCTOValue(const aValue: String);
    function GetCOLORValue: String;
    procedure SetCOLORValue(const aValue: String);
    function GetTIPO_PRODUCTOValue: String;
    procedure SetTIPO_PRODUCTOValue(const aValue: String);
    function GetGRUPO_PRODUCTOValue: String;
    procedure SetGRUPO_PRODUCTOValue(const aValue: String);
    function GetCOLECCIONValue: String;
    procedure SetCOLECCIONValue(const aValue: String);
    function GetI38Value: Float;
    procedure SetI38Value(const aValue: Float);
    function GetI40Value: Float;
    procedure SetI40Value(const aValue: Float);
    function GetI42Value: Float;
    procedure SetI42Value(const aValue: Float);
    function GetI44Value: Float;
    procedure SetI44Value(const aValue: Float);
    function GetI46Value: Float;
    procedure SetI46Value(const aValue: Float);
    function GetI48Value: Float;
    procedure SetI48Value(const aValue: Float);
    function GetTIValue: Float;
    procedure SetTIValue(const aValue: Float);
    function GetK38Value: Float;
    procedure SetK38Value(const aValue: Float);
    function GetK40Value: Float;
    procedure SetK40Value(const aValue: Float);
    function GetK42Value: Float;
    procedure SetK42Value(const aValue: Float);
    function GetK44Value: Float;
    procedure SetK44Value(const aValue: Float);
    function GetK46Value: Float;
    procedure SetK46Value(const aValue: Float);
    function GetK48Value: Float;
    procedure SetK48Value(const aValue: Float);
    function GetTKValue: Float;
    procedure SetTKValue(const aValue: Float);
    function GetD38Value: Float;
    procedure SetD38Value(const aValue: Float);
    function GetD40Value: Float;
    procedure SetD40Value(const aValue: Float);
    function GetD42Value: Float;
    procedure SetD42Value(const aValue: Float);
    function GetD44Value: Float;
    procedure SetD44Value(const aValue: Float);
    function GetD46Value: Float;
    procedure SetD46Value(const aValue: Float);
    function GetD48Value: Float;
    procedure SetD48Value(const aValue: Float);
    function GetDTValue: Float;
    procedure SetDTValue(const aValue: Float);


    { Properties }
    property CENTRO: String read GetCENTROValue write SetCENTROValue;
    property CODIGO: String read GetCODIGOValue write SetCODIGOValue;
    property PRODUCTO: String read GetPRODUCTOValue write SetPRODUCTOValue;
    property COLOR: String read GetCOLORValue write SetCOLORValue;
    property TIPO_PRODUCTO: String read GetTIPO_PRODUCTOValue write SetTIPO_PRODUCTOValue;
    property GRUPO_PRODUCTO: String read GetGRUPO_PRODUCTOValue write SetGRUPO_PRODUCTOValue;
    property COLECCION: String read GetCOLECCIONValue write SetCOLECCIONValue;
    property I38: Float read GetI38Value write SetI38Value;
    property I40: Float read GetI40Value write SetI40Value;
    property I42: Float read GetI42Value write SetI42Value;
    property I44: Float read GetI44Value write SetI44Value;
    property I46: Float read GetI46Value write SetI46Value;
    property I48: Float read GetI48Value write SetI48Value;
    property TI: Float read GetTIValue write SetTIValue;
    property K38: Float read GetK38Value write SetK38Value;
    property K40: Float read GetK40Value write SetK40Value;
    property K42: Float read GetK42Value write SetK42Value;
    property K44: Float read GetK44Value write SetK44Value;
    property K46: Float read GetK46Value write SetK46Value;
    property K48: Float read GetK48Value write SetK48Value;
    property TK: Float read GetTKValue write SetTKValue;
    property D38: Float read GetD38Value write SetD38Value;
    property D40: Float read GetD40Value write SetD40Value;
    property D42: Float read GetD42Value write SetD42Value;
    property D44: Float read GetD44Value write SetD44Value;
    property D46: Float read GetD46Value write SetD46Value;
    property D48: Float read GetD48Value write SetD48Value;
    property DT: Float read GetDTValue write SetDTValue;
  end;

  { TStockEDIInventarioDataTableRules }
  TStockEDIInventarioDataTableRules = class(TDADataTableRules, IStockEDIInventario)
  private
  protected
    { Property getters and setters }
    function GetCENTROValue: String; virtual;
    procedure SetCENTROValue(const aValue: String); virtual;
    function GetCODIGOValue: String; virtual;
    procedure SetCODIGOValue(const aValue: String); virtual;
    function GetPRODUCTOValue: String; virtual;
    procedure SetPRODUCTOValue(const aValue: String); virtual;
    function GetCOLORValue: String; virtual;
    procedure SetCOLORValue(const aValue: String); virtual;
    function GetTIPO_PRODUCTOValue: String; virtual;
    procedure SetTIPO_PRODUCTOValue(const aValue: String); virtual;
    function GetGRUPO_PRODUCTOValue: String; virtual;
    procedure SetGRUPO_PRODUCTOValue(const aValue: String); virtual;
    function GetCOLECCIONValue: String; virtual;
    procedure SetCOLECCIONValue(const aValue: String); virtual;
    function GetI38Value: Float; virtual;
    procedure SetI38Value(const aValue: Float); virtual;
    function GetI40Value: Float; virtual;
    procedure SetI40Value(const aValue: Float); virtual;
    function GetI42Value: Float; virtual;
    procedure SetI42Value(const aValue: Float); virtual;
    function GetI44Value: Float; virtual;
    procedure SetI44Value(const aValue: Float); virtual;
    function GetI46Value: Float; virtual;
    procedure SetI46Value(const aValue: Float); virtual;
    function GetI48Value: Float; virtual;
    procedure SetI48Value(const aValue: Float); virtual;
    function GetTIValue: Float; virtual;
    procedure SetTIValue(const aValue: Float); virtual;
    function GetK38Value: Float; virtual;
    procedure SetK38Value(const aValue: Float); virtual;
    function GetK40Value: Float; virtual;
    procedure SetK40Value(const aValue: Float); virtual;
    function GetK42Value: Float; virtual;
    procedure SetK42Value(const aValue: Float); virtual;
    function GetK44Value: Float; virtual;
    procedure SetK44Value(const aValue: Float); virtual;
    function GetK46Value: Float; virtual;
    procedure SetK46Value(const aValue: Float); virtual;
    function GetK48Value: Float; virtual;
    procedure SetK48Value(const aValue: Float); virtual;
    function GetTKValue: Float; virtual;
    procedure SetTKValue(const aValue: Float); virtual;
    function GetD38Value: Float; virtual;
    procedure SetD38Value(const aValue: Float); virtual;
    function GetD40Value: Float; virtual;
    procedure SetD40Value(const aValue: Float); virtual;
    function GetD42Value: Float; virtual;
    procedure SetD42Value(const aValue: Float); virtual;
    function GetD44Value: Float; virtual;
    procedure SetD44Value(const aValue: Float); virtual;
    function GetD46Value: Float; virtual;
    procedure SetD46Value(const aValue: Float); virtual;
    function GetD48Value: Float; virtual;
    procedure SetD48Value(const aValue: Float); virtual;
    function GetDTValue: Float; virtual;
    procedure SetDTValue(const aValue: Float); virtual;

    { Properties }
    property CENTRO: String read GetCENTROValue write SetCENTROValue;
    property CODIGO: String read GetCODIGOValue write SetCODIGOValue;
    property PRODUCTO: String read GetPRODUCTOValue write SetPRODUCTOValue;
    property COLOR: String read GetCOLORValue write SetCOLORValue;
    property TIPO_PRODUCTO: String read GetTIPO_PRODUCTOValue write SetTIPO_PRODUCTOValue;
    property GRUPO_PRODUCTO: String read GetGRUPO_PRODUCTOValue write SetGRUPO_PRODUCTOValue;
    property COLECCION: String read GetCOLECCIONValue write SetCOLECCIONValue;
    property I38: Float read GetI38Value write SetI38Value;
    property I40: Float read GetI40Value write SetI40Value;
    property I42: Float read GetI42Value write SetI42Value;
    property I44: Float read GetI44Value write SetI44Value;
    property I46: Float read GetI46Value write SetI46Value;
    property I48: Float read GetI48Value write SetI48Value;
    property TI: Float read GetTIValue write SetTIValue;
    property K38: Float read GetK38Value write SetK38Value;
    property K40: Float read GetK40Value write SetK40Value;
    property K42: Float read GetK42Value write SetK42Value;
    property K44: Float read GetK44Value write SetK44Value;
    property K46: Float read GetK46Value write SetK46Value;
    property K48: Float read GetK48Value write SetK48Value;
    property TK: Float read GetTKValue write SetTKValue;
    property D38: Float read GetD38Value write SetD38Value;
    property D40: Float read GetD40Value write SetD40Value;
    property D42: Float read GetD42Value write SetD42Value;
    property D44: Float read GetD44Value write SetD44Value;
    property D46: Float read GetD46Value write SetD46Value;
    property D48: Float read GetD48Value write SetD48Value;
    property DT: Float read GetDTValue write SetDTValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants;

{ TStockPrendasCentrosDataTableRules }
constructor TStockPrendasCentrosDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TStockPrendasCentrosDataTableRules.Destroy;
begin
  inherited;
end;

function TStockPrendasCentrosDataTableRules.GetCODIGOValue: String;
begin
  result := DataTable.Fields[idx_StockPrendasCentrosCODIGO].AsString;
end;

procedure TStockPrendasCentrosDataTableRules.SetCODIGOValue(const aValue: String);
begin
  DataTable.Fields[idx_StockPrendasCentrosCODIGO].AsString := aValue;
end;

function TStockPrendasCentrosDataTableRules.GetPRODUCTOValue: String;
begin
  result := DataTable.Fields[idx_StockPrendasCentrosPRODUCTO].AsString;
end;

procedure TStockPrendasCentrosDataTableRules.SetPRODUCTOValue(const aValue: String);
begin
  DataTable.Fields[idx_StockPrendasCentrosPRODUCTO].AsString := aValue;
end;

function TStockPrendasCentrosDataTableRules.GetTIPO_PRODUCTOValue: String;
begin
  result := DataTable.Fields[idx_StockPrendasCentrosTIPO_PRODUCTO].AsString;
end;

procedure TStockPrendasCentrosDataTableRules.SetTIPO_PRODUCTOValue(const aValue: String);
begin
  DataTable.Fields[idx_StockPrendasCentrosTIPO_PRODUCTO].AsString := aValue;
end;

function TStockPrendasCentrosDataTableRules.GetGRUPO_PRODUCTOValue: String;
begin
  result := DataTable.Fields[idx_StockPrendasCentrosGRUPO_PRODUCTO].AsString;
end;

procedure TStockPrendasCentrosDataTableRules.SetGRUPO_PRODUCTOValue(const aValue: String);
begin
  DataTable.Fields[idx_StockPrendasCentrosGRUPO_PRODUCTO].AsString := aValue;
end;

function TStockPrendasCentrosDataTableRules.GetCOLECCIONValue: String;
begin
  result := DataTable.Fields[idx_StockPrendasCentrosCOLECCION].AsString;
end;

procedure TStockPrendasCentrosDataTableRules.SetCOLECCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_StockPrendasCentrosCOLECCION].AsString := aValue;
end;

function TStockPrendasCentrosDataTableRules.GetCOLORValue: String;
begin
  result := DataTable.Fields[idx_StockPrendasCentrosCOLOR].AsString;
end;

procedure TStockPrendasCentrosDataTableRules.SetCOLORValue(const aValue: String);
begin
  DataTable.Fields[idx_StockPrendasCentrosCOLOR].AsString := aValue;
end;

function TStockPrendasCentrosDataTableRules.GetT38Value: Float;
begin
  result := DataTable.Fields[idx_StockPrendasCentrosT38].AsFloat;
end;

procedure TStockPrendasCentrosDataTableRules.SetT38Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockPrendasCentrosT38].AsFloat := aValue;
end;

function TStockPrendasCentrosDataTableRules.GetT40Value: Float;
begin
  result := DataTable.Fields[idx_StockPrendasCentrosT40].AsFloat;
end;

procedure TStockPrendasCentrosDataTableRules.SetT40Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockPrendasCentrosT40].AsFloat := aValue;
end;

function TStockPrendasCentrosDataTableRules.GetT42Value: Float;
begin
  result := DataTable.Fields[idx_StockPrendasCentrosT42].AsFloat;
end;

procedure TStockPrendasCentrosDataTableRules.SetT42Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockPrendasCentrosT42].AsFloat := aValue;
end;

function TStockPrendasCentrosDataTableRules.GetT44Value: Float;
begin
  result := DataTable.Fields[idx_StockPrendasCentrosT44].AsFloat;
end;

procedure TStockPrendasCentrosDataTableRules.SetT44Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockPrendasCentrosT44].AsFloat := aValue;
end;

function TStockPrendasCentrosDataTableRules.GetT46Value: Float;
begin
  result := DataTable.Fields[idx_StockPrendasCentrosT46].AsFloat;
end;

procedure TStockPrendasCentrosDataTableRules.SetT46Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockPrendasCentrosT46].AsFloat := aValue;
end;

function TStockPrendasCentrosDataTableRules.GetT48Value: Float;
begin
  result := DataTable.Fields[idx_StockPrendasCentrosT48].AsFloat;
end;

procedure TStockPrendasCentrosDataTableRules.SetT48Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockPrendasCentrosT48].AsFloat := aValue;
end;

function TStockPrendasCentrosDataTableRules.GetTOTALValue: Float;
begin
  result := DataTable.Fields[idx_StockPrendasCentrosTOTAL].AsFloat;
end;

procedure TStockPrendasCentrosDataTableRules.SetTOTALValue(const aValue: Float);
begin
  DataTable.Fields[idx_StockPrendasCentrosTOTAL].AsFloat := aValue;
end;


{ TStockEDIDataTableRules }
constructor TStockEDIDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TStockEDIDataTableRules.Destroy;
begin
  inherited;
end;

function TStockEDIDataTableRules.GetCENTROValue: String;
begin
  result := DataTable.Fields[idx_StockEDICENTRO].AsString;
end;

procedure TStockEDIDataTableRules.SetCENTROValue(const aValue: String);
begin
  DataTable.Fields[idx_StockEDICENTRO].AsString := aValue;
end;

function TStockEDIDataTableRules.GetCODIGOValue: String;
begin
  result := DataTable.Fields[idx_StockEDICODIGO].AsString;
end;

procedure TStockEDIDataTableRules.SetCODIGOValue(const aValue: String);
begin
  DataTable.Fields[idx_StockEDICODIGO].AsString := aValue;
end;

function TStockEDIDataTableRules.GetPRODUCTOValue: String;
begin
  result := DataTable.Fields[idx_StockEDIPRODUCTO].AsString;
end;

procedure TStockEDIDataTableRules.SetPRODUCTOValue(const aValue: String);
begin
  DataTable.Fields[idx_StockEDIPRODUCTO].AsString := aValue;
end;

function TStockEDIDataTableRules.GetTIPO_PRODUCTOValue: String;
begin
  result := DataTable.Fields[idx_StockEDITIPO_PRODUCTO].AsString;
end;

procedure TStockEDIDataTableRules.SetTIPO_PRODUCTOValue(const aValue: String);
begin
  DataTable.Fields[idx_StockEDITIPO_PRODUCTO].AsString := aValue;
end;

function TStockEDIDataTableRules.GetGRUPO_PRODUCTOValue: String;
begin
  result := DataTable.Fields[idx_StockEDIGRUPO_PRODUCTO].AsString;
end;

procedure TStockEDIDataTableRules.SetGRUPO_PRODUCTOValue(const aValue: String);
begin
  DataTable.Fields[idx_StockEDIGRUPO_PRODUCTO].AsString := aValue;
end;

function TStockEDIDataTableRules.GetCOLECCIONValue: String;
begin
  result := DataTable.Fields[idx_StockEDICOLECCION].AsString;
end;

procedure TStockEDIDataTableRules.SetCOLECCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_StockEDICOLECCION].AsString := aValue;
end;

function TStockEDIDataTableRules.GetCOLORValue: String;
begin
  result := DataTable.Fields[idx_StockEDICOLOR].AsString;
end;

procedure TStockEDIDataTableRules.SetCOLORValue(const aValue: String);
begin
  DataTable.Fields[idx_StockEDICOLOR].AsString := aValue;
end;

function TStockEDIDataTableRules.GetE38Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIE38].AsFloat;
end;

procedure TStockEDIDataTableRules.SetE38Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIE38].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetE40Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIE40].AsFloat;
end;

procedure TStockEDIDataTableRules.SetE40Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIE40].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetE42Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIE42].AsFloat;
end;

procedure TStockEDIDataTableRules.SetE42Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIE42].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetE44Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIE44].AsFloat;
end;

procedure TStockEDIDataTableRules.SetE44Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIE44].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetE46Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIE46].AsFloat;
end;

procedure TStockEDIDataTableRules.SetE46Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIE46].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetE48Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIE48].AsFloat;
end;

procedure TStockEDIDataTableRules.SetE48Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIE48].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetTEValue: Float;
begin
  result := DataTable.Fields[idx_StockEDITE].AsFloat;
end;

procedure TStockEDIDataTableRules.SetTEValue(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDITE].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetS38Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIS38].AsFloat;
end;

procedure TStockEDIDataTableRules.SetS38Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIS38].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetS40Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIS40].AsFloat;
end;

procedure TStockEDIDataTableRules.SetS40Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIS40].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetS42Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIS42].AsFloat;
end;

procedure TStockEDIDataTableRules.SetS42Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIS42].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetS44Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIS44].AsFloat;
end;

procedure TStockEDIDataTableRules.SetS44Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIS44].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetS46Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIS46].AsFloat;
end;

procedure TStockEDIDataTableRules.SetS46Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIS46].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetS48Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIS48].AsFloat;
end;

procedure TStockEDIDataTableRules.SetS48Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIS48].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetTSValue: Float;
begin
  result := DataTable.Fields[idx_StockEDITS].AsFloat;
end;

procedure TStockEDIDataTableRules.SetTSValue(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDITS].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetK38Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIK38].AsFloat;
end;

procedure TStockEDIDataTableRules.SetK38Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIK38].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetK40Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIK40].AsFloat;
end;

procedure TStockEDIDataTableRules.SetK40Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIK40].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetK42Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIK42].AsFloat;
end;

procedure TStockEDIDataTableRules.SetK42Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIK42].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetK44Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIK44].AsFloat;
end;

procedure TStockEDIDataTableRules.SetK44Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIK44].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetK46Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIK46].AsFloat;
end;

procedure TStockEDIDataTableRules.SetK46Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIK46].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetK48Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIK48].AsFloat;
end;

procedure TStockEDIDataTableRules.SetK48Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIK48].AsFloat := aValue;
end;

function TStockEDIDataTableRules.GetKTValue: Float;
begin
  result := DataTable.Fields[idx_StockEDIKT].AsFloat;
end;

procedure TStockEDIDataTableRules.SetKTValue(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIKT].AsFloat := aValue;
end;


{ TStockVARELADataTableRules }
constructor TStockVARELADataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TStockVARELADataTableRules.Destroy;
begin
  inherited;
end;

function TStockVARELADataTableRules.GetFILIALValue: String;
begin
  result := DataTable.Fields[idx_StockVARELAFILIAL].AsString;
end;

procedure TStockVARELADataTableRules.SetFILIALValue(const aValue: String);
begin
  DataTable.Fields[idx_StockVARELAFILIAL].AsString := aValue;
end;

function TStockVARELADataTableRules.GetCODIGOValue: String;
begin
  result := DataTable.Fields[idx_StockVARELACODIGO].AsString;
end;

procedure TStockVARELADataTableRules.SetCODIGOValue(const aValue: String);
begin
  DataTable.Fields[idx_StockVARELACODIGO].AsString := aValue;
end;

function TStockVARELADataTableRules.GetCOLORValue: String;
begin
  result := DataTable.Fields[idx_StockVARELACOLOR].AsString;
end;

procedure TStockVARELADataTableRules.SetCOLORValue(const aValue: String);
begin
  DataTable.Fields[idx_StockVARELACOLOR].AsString := aValue;
end;

function TStockVARELADataTableRules.GetPRODUCTOValue: String;
begin
  result := DataTable.Fields[idx_StockVARELAPRODUCTO].AsString;
end;

procedure TStockVARELADataTableRules.SetPRODUCTOValue(const aValue: String);
begin
  DataTable.Fields[idx_StockVARELAPRODUCTO].AsString := aValue;
end;

function TStockVARELADataTableRules.GetTIPO_PRODUTOValue: String;
begin
  result := DataTable.Fields[idx_StockVARELATIPO_PRODUTO].AsString;
end;

procedure TStockVARELADataTableRules.SetTIPO_PRODUTOValue(const aValue: String);
begin
  DataTable.Fields[idx_StockVARELATIPO_PRODUTO].AsString := aValue;
end;

function TStockVARELADataTableRules.GetGRUPO_PRODUTOValue: String;
begin
  result := DataTable.Fields[idx_StockVARELAGRUPO_PRODUTO].AsString;
end;

procedure TStockVARELADataTableRules.SetGRUPO_PRODUTOValue(const aValue: String);
begin
  DataTable.Fields[idx_StockVARELAGRUPO_PRODUTO].AsString := aValue;
end;

function TStockVARELADataTableRules.GetCOLECCIONValue: String;
begin
  result := DataTable.Fields[idx_StockVARELACOLECCION].AsString;
end;

procedure TStockVARELADataTableRules.SetCOLECCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_StockVARELACOLECCION].AsString := aValue;
end;

function TStockVARELADataTableRules.GetK38Value: Integer;
begin
  result := DataTable.Fields[idx_StockVARELAK38].AsInteger;
end;

procedure TStockVARELADataTableRules.SetK38Value(const aValue: Integer);
begin
  DataTable.Fields[idx_StockVARELAK38].AsInteger := aValue;
end;

function TStockVARELADataTableRules.GetK40Value: Integer;
begin
  result := DataTable.Fields[idx_StockVARELAK40].AsInteger;
end;

procedure TStockVARELADataTableRules.SetK40Value(const aValue: Integer);
begin
  DataTable.Fields[idx_StockVARELAK40].AsInteger := aValue;
end;

function TStockVARELADataTableRules.GetK42Value: Integer;
begin
  result := DataTable.Fields[idx_StockVARELAK42].AsInteger;
end;

procedure TStockVARELADataTableRules.SetK42Value(const aValue: Integer);
begin
  DataTable.Fields[idx_StockVARELAK42].AsInteger := aValue;
end;

function TStockVARELADataTableRules.GetK44Value: Integer;
begin
  result := DataTable.Fields[idx_StockVARELAK44].AsInteger;
end;

procedure TStockVARELADataTableRules.SetK44Value(const aValue: Integer);
begin
  DataTable.Fields[idx_StockVARELAK44].AsInteger := aValue;
end;

function TStockVARELADataTableRules.GetK46Value: Integer;
begin
  result := DataTable.Fields[idx_StockVARELAK46].AsInteger;
end;

procedure TStockVARELADataTableRules.SetK46Value(const aValue: Integer);
begin
  DataTable.Fields[idx_StockVARELAK46].AsInteger := aValue;
end;

function TStockVARELADataTableRules.GetK48Value: Integer;
begin
  result := DataTable.Fields[idx_StockVARELAK48].AsInteger;
end;

procedure TStockVARELADataTableRules.SetK48Value(const aValue: Integer);
begin
  DataTable.Fields[idx_StockVARELAK48].AsInteger := aValue;
end;

function TStockVARELADataTableRules.GetKTValue: Integer;
begin
  result := DataTable.Fields[idx_StockVARELAKT].AsInteger;
end;

procedure TStockVARELADataTableRules.SetKTValue(const aValue: Integer);
begin
  DataTable.Fields[idx_StockVARELAKT].AsInteger := aValue;
end;


{ TStockEDIInventarioDataTableRules }
constructor TStockEDIInventarioDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TStockEDIInventarioDataTableRules.Destroy;
begin
  inherited;
end;

function TStockEDIInventarioDataTableRules.GetCENTROValue: String;
begin
  result := DataTable.Fields[idx_StockEDIInventarioCENTRO].AsString;
end;

procedure TStockEDIInventarioDataTableRules.SetCENTROValue(const aValue: String);
begin
  DataTable.Fields[idx_StockEDIInventarioCENTRO].AsString := aValue;
end;

function TStockEDIInventarioDataTableRules.GetCODIGOValue: String;
begin
  result := DataTable.Fields[idx_StockEDIInventarioCODIGO].AsString;
end;

procedure TStockEDIInventarioDataTableRules.SetCODIGOValue(const aValue: String);
begin
  DataTable.Fields[idx_StockEDIInventarioCODIGO].AsString := aValue;
end;

function TStockEDIInventarioDataTableRules.GetPRODUCTOValue: String;
begin
  result := DataTable.Fields[idx_StockEDIInventarioPRODUCTO].AsString;
end;

procedure TStockEDIInventarioDataTableRules.SetPRODUCTOValue(const aValue: String);
begin
  DataTable.Fields[idx_StockEDIInventarioPRODUCTO].AsString := aValue;
end;

function TStockEDIInventarioDataTableRules.GetCOLORValue: String;
begin
  result := DataTable.Fields[idx_StockEDIInventarioCOLOR].AsString;
end;

procedure TStockEDIInventarioDataTableRules.SetCOLORValue(const aValue: String);
begin
  DataTable.Fields[idx_StockEDIInventarioCOLOR].AsString := aValue;
end;

function TStockEDIInventarioDataTableRules.GetTIPO_PRODUCTOValue: String;
begin
  result := DataTable.Fields[idx_StockEDIInventarioTIPO_PRODUCTO].AsString;
end;

procedure TStockEDIInventarioDataTableRules.SetTIPO_PRODUCTOValue(const aValue: String);
begin
  DataTable.Fields[idx_StockEDIInventarioTIPO_PRODUCTO].AsString := aValue;
end;

function TStockEDIInventarioDataTableRules.GetGRUPO_PRODUCTOValue: String;
begin
  result := DataTable.Fields[idx_StockEDIInventarioGRUPO_PRODUCTO].AsString;
end;

procedure TStockEDIInventarioDataTableRules.SetGRUPO_PRODUCTOValue(const aValue: String);
begin
  DataTable.Fields[idx_StockEDIInventarioGRUPO_PRODUCTO].AsString := aValue;
end;

function TStockEDIInventarioDataTableRules.GetCOLECCIONValue: String;
begin
  result := DataTable.Fields[idx_StockEDIInventarioCOLECCION].AsString;
end;

procedure TStockEDIInventarioDataTableRules.SetCOLECCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_StockEDIInventarioCOLECCION].AsString := aValue;
end;

function TStockEDIInventarioDataTableRules.GetI38Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioI38].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetI38Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioI38].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetI40Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioI40].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetI40Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioI40].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetI42Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioI42].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetI42Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioI42].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetI44Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioI44].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetI44Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioI44].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetI46Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioI46].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetI46Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioI46].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetI48Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioI48].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetI48Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioI48].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetTIValue: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioTI].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetTIValue(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioTI].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetK38Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioK38].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetK38Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioK38].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetK40Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioK40].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetK40Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioK40].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetK42Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioK42].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetK42Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioK42].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetK44Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioK44].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetK44Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioK44].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetK46Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioK46].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetK46Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioK46].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetK48Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioK48].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetK48Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioK48].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetTKValue: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioTK].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetTKValue(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioTK].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetD38Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioD38].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetD38Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioD38].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetD40Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioD40].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetD40Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioD40].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetD42Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioD42].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetD42Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioD42].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetD44Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioD44].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetD44Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioD44].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetD46Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioD46].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetD46Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioD46].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetD48Value: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioD48].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetD48Value(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioD48].AsFloat := aValue;
end;

function TStockEDIInventarioDataTableRules.GetDTValue: Float;
begin
  result := DataTable.Fields[idx_StockEDIInventarioDT].AsFloat;
end;

procedure TStockEDIInventarioDataTableRules.SetDTValue(const aValue: Float);
begin
  DataTable.Fields[idx_StockEDIInventarioDT].AsFloat := aValue;
end;


initialization
  RegisterDataTableRules(RID_StockPrendasCentros, TStockPrendasCentrosDataTableRules);
  RegisterDataTableRules(RID_StockEDI, TStockEDIDataTableRules);
  RegisterDataTableRules(RID_StockVARELA, TStockVARELADataTableRules);
  RegisterDataTableRules(RID_StockEDIInventario, TStockEDIInventarioDataTableRules);

end.
